> For the complete documentation index, see [llms.txt](https://disdat.gitbook.io/disdat-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://disdat.gitbook.io/disdat-documentation/reference/dsdt-the-cli/dsdt-apply.md).

# dsdt apply

### Description

Assuming you have defined a Disdat DAG of one or more tasks where:

* `package`: The Python package (directory with a `__init__.py` file) containing your module
* `module`: The module containing the Disdat class you wish to run
* `class`: The name of the class that defines yrou Disdat task

### Usage

```
usage: dsdt apply [-h] [-cs] [-w WORKERS] [-it INPUT_TAG] [-ot OUTPUT_TAG]
                  [-o OUTPUT_BUNDLE] [-f] [--force-all] [--incremental-push]
                  [--incremental-pull]
                  pipe_cls ...

```

### Options

```
positional arguments:
  pipe_cls              User-defined transform, e.g., 'module.PipeClass'
  params                Optional set of parameters for this pipe '--parameter
                        value'

optional arguments:
  -h, --help            show this help message and exit
  -cs, --central-scheduler
                        Use a central Luigi scheduler (defaults to local
                        scheduler)
  -w WORKERS, --workers WORKERS
                        Number of Luigi workers on this node
  -it INPUT_TAG, --input-tag INPUT_TAG
                        Input bundle tags: '-it authoritative:True -it
                        version:0.7.1'
  -ot OUTPUT_TAG, --output-tag OUTPUT_TAG
                        Output bundle tags: '-ot authoritative:True -ot
                        version:0.7.1'
  -o OUTPUT_BUNDLE, --output-bundle OUTPUT_BUNDLE
                        Name output bundle: '-o my.output.bundle'. Default
                        name is '<TaskName>_<param_hash>'
  -f, --force           Force re-computation of only this task.
  --force-all           Force re-computation of ALL upstream tasks.
  --incremental-push    Commit and push each task's bundle as it is produced
                        to the remote.
  --incremental-pull    Localize bundles as they are needed by downstream
                        tasks from the remote.
```

### Examples

#### Tutorial: [running the pipeline](/disdat-documentation/examples/short-test-drive/untitled.md#running-the-pipeline)

```bash
$dsdt apply pipelines.mnist.Train
```

#### Forcing the last task to execute:

```bash
$dsdt apply -f pipelines.mnist.Train
```

#### Naming the output bundle and adding tags:

```bash
$dsdt apply -o mnist.trained -ot org:data_science pipelines.mnist.Train
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://disdat.gitbook.io/disdat-documentation/reference/dsdt-the-cli/dsdt-apply.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
